#!/bin/sh
#if [ "$1" = "0" ] ; then true # last uninstall
ps -aef|grep wsesamd|grep -v grep > /dev/null 2>&1
if [ $? -eq 0 ]
then
        /opt/ibm/edge/admin/wsesamd/bin/wsesamd -kill
        if [ $? -ne 0 ]
        then
                echo  "Error: Unable to stop the Administrative Runtime Daemon"
                echo ""
        fi
fi
save_files ()
{
FROM_DIR=$1
shift
for i in $*
do
        if [ -f ${FROM_DIR}/${i} ]
        then
                cp -p ${FROM_DIR}/${i} ${oldfiles_dir}/${i}.${DTSTAMP}
                cp -p ${FROM_DIR}/${i} ${oldfiles_dir}
                if [ $? -eq 0 ]
                then
                        COPYMADE=Y
                else
                        ERROR_COPYING="Y"
                fi
        fi
done
}

# save off config file

WES_HOME=/opt/ibm/edge
COMPONENT=admin
APP_HOME=${WES_HOME}/${COMPONENT}
ERROR_COPYING=N
COPYMADE=N

if [ `uname` = "Linux" ]
then
        MYDATE=/bin/date
else
        MYDATE=/usr/bin/date
fi
DTSTAMP=`${MYDATE} '+%y''%m''%d''%H''%M''%SOURCE'`

oldfiles_dir=${WES_HOME}/oldfiles/${COMPONENT}

if [ ! -d ${oldfiles_dir} ]
then
        mkdir -p ${oldfiles_dir}
fi

save_files ${APP_HOME}/wsesamd/bin/wsesamd.d \
                        amd.kdb amd.crl amd.pf amd.rdb apps

save_files ${APP_HOME}/wsesamd/bin hosts.allow hosts.deny

if [ ${ERROR_COPYING} = "Y" ]; then
        echo ""
        echo "Error copying configuration files to ${oldfiles_dir},"
        echo "not all files saved."
        echo ""
elif [ ${COPYMADE} = "Y" ]; then
        echo ""
        echo "Configuration files have been saved in ${oldfiles_dir}"
        echo ""
fi


# The file that contains application registry data should not be left around
if [ -f $APP_HOME/wsesamd/bin/wsesamd.d/apps ]
then
        rm -f $APP_HOME/wsesamd/bin/wsesamd.d/apps
fi
# Delete any *.new files created during installation
if [ -f $APP_HOME/wsesamd/bin/hosts.allow.new ]
then
        rm -f $APP_HOME/wsesamd/bin/hosts.allow.new
        rm -f $APP_HOME/wsesamd/bin/hosts.deny.new
fi
#fi
