#!/bin/sh
# If the proxy is running, stop it.
#if [ "$1" = "0" ] ; then true # last uninstall
if [ $[`ps ax | awk '{ print $5 }' | grep /usr/sbin/ibmproxy > /dev/null 2>&1`] ]; then
        if [ -f /etc/redhat-release ]; then     # /etc/redhat-release
                proxyscript="/etc/rc.d/init.d/ibmproxy"
        else
                proxyscript="/etc/init.d/ibmproxy"
        fi
        if [ -x ${proxyscript} ] ; then
                ${proxyscript} stop > /dev/null 2>&1
        fi
fi
# In case "ibmproxy stop " fails:
pid=`ps -e | grep ibmproxy | awk '{ print $1 }' `
if [ X"${pid}" != X"" ]
  then
   kill -9  $pid
fi


# Do special processing on socks.conf if it exists
# if a link, create a copy in etc, otherwise it would be a broken link

if [ -h /etc/socks.conf ]; then
   cp -p /etc/socks.conf /etc/socks.conf.$$
   \rm -f /etc/socks.conf
   mv /etc/socks.conf.$$ /etc/socks.conf
fi
# Save all files in a directory
save_files ()
{
FROM_DIR=$1
DEL_FILE=$2
shift 2
for i in $*
do
   if [ -d ${FROM_DIR} ]
   then
        if [ -f ${FROM_DIR}/${i} ]
        then
                cp -p ${FROM_DIR}/${i} ${oldfiles_dir}/${i}.${DATE_SFX}
                cp -fp ${FROM_DIR}/${i} ${oldfiles_dir}
                if [ $? -eq 0 ]
                then
                        if [ "${DEL_FILE}" = "TRUE" ]
                        then
                                rm -f ${FROM_DIR}/${i}
                        fi
                        COPYMADE="Y"
                else
                        ERROR_COPYING="Y"
                fi
        fi
   fi
done
}

# Search a directory list for a copy of the file and save the first one found
save_file_in_dirs ()
{
NOT_FOUND="TRUE"
file_to_save=$1
shift
for dir in $*
do
   if [ -d ${dir} ]
   then
        if [ ${NOT_FOUND} = "TRUE" -a -f ${dir}/$file_to_save ]
        then
           NOT_FOUND="FALSE"
           if [ ${dir} != ${oldfiles_dir} ]
           then
                cp -p ${dir}/${file_to_save} ${oldfiles_dir}/${file_to_save}.${DATE_SFX}
                cp -fp ${dir}/${file_to_save} $oldfiles_dir
                if [ $? -eq 0 ]
                then
                        FILECOPYMADE="Y"
                else
                        ERROR_COPYING="Y"
                fi
           fi
        fi
   fi
done
}

save_dirs ()
{
FROM_DIR=$1
DEL_DIR=$2
shift 2
for i in $*
do
        if [ -d ${FROM_DIR}/${i} ]
        then
                # On Linux, when copying directories, links within them are
                # copied as links; use -L to stop that
                if [ `uname` = "Linux" ]
                then
                        cflags="-rLfp"
                else
                        cflags="-rfp"
                fi

                cp ${cflags} ${FROM_DIR}/${i} ${oldfiles_dir}/${i}.${DATE_SFX}
                cp ${cflags} ${FROM_DIR}/${i} ${oldfiles_dir}

                if [ $? -eq 0 ]
                then
                        if [ "${DEL_DIR}" = "TRUE" ]
                        then
                                rm -rf ${FROM_DIR}/${i}
                        fi
                        COPYMADE=Y
                else
                        ERROR_COPYING="Y"
                fi
        fi
done
}


WES_HOME=/opt/ibm/edge
COMPONENT=cp
APP_HOME=$WES_HOME/$COMPONENT
oldfiles_dir=$WES_HOME/oldfiles/$COMPONENT

OLD_APPHOME="/opt/IBMWTE/usr/internet"
old_oldfiles="${OLD_APPHOME}/server_root/oldfiles"

AIX_GA35="/usr/lpp/internet"    # used for AIX only
aixga35_oldfiles=${AIX_GA35}/server_root/oldfiles


COPYMADE="N"
FILECOPYMADE="N"
DIRCOPYMADE="N"
ERROR_COPYING="N"

# These values are used to indicate if a file should be deleted
# after it is saved. Normally, generated files are deleted.
GENERATED_FILE="TRUE"
INSTALLED_FILE="FALSE"

if [ `uname` = "Linux" ]
then
        DATE=/bin/date
else
        DATE=/usr/bin/date
fi
DATE_SFX=`$DATE '+%y''%m''%d''%H''%M''%SOURCE'`

if [ ! -d ${oldfiles_dir} ]
then
        mkdir -p ${oldfiles_dir}
fi
# Save current config files before uninstalling

save_files /etc ${INSTALLED_FILE} socks.conf

# These files should have links in /etc

file_list="pac.conf pacpolicy.conf paccp.conf"
for filename in $file_list
do
        save_file_in_dirs $filename /etc ${APP_HOME}/etc
done

# Save webadmin files as a group
save_files ${APP_HOME}/server_root/protect ${INSTALLED_FILE} \
                webadmin.group webadmin.passwd webadmin.passwd.bak

# Split the cyberpatrol files into installed file(s) and generated files,
# because the generated files should be deleted on uninstall.
save_files ${APP_HOME}/server_root/filter/cyberpatrol ${INSTALLED_FILE} \
                setup_state

save_files ${APP_HOME}/server_root/filter/cyberpatrol ${GENERATED_FILE} \
                .cpauthinit registration.data

# File used for content distribution
save_files ${APP_HOME}/server_root/data ${GENERATED_FILE} mappingtbl

# Save the logs
if [ -d "${APP_HOME}/server_root/logs" -a -d ${oldfiles_dir} ]
then
        if [ -d "${oldfiles_dir}/logs" ]
        then
                mv ${APP_HOME}/server_root/logs/* ${oldfiles_dir}/logs
                rm -rf ${APP_HOME}/server_root/logs
        else
                mv ${APP_HOME}/server_root/logs ${oldfiles_dir}/oldfiles
        fi
fi
# set copymade to any "YES" result
if [ "$COPYMADE" = "Y" -o "$FILECOPYMADE" = "Y" -o "$DIRCOPYMADE" = "Y" ]; then
        COPYMADE="Y"
fi
if [ ${ERROR_COPYING} = "Y" ]; then
        echo ""
        echo "Error copying configuration files to ${oldfiles_dir},"
        echo "not all files saved."
        echo ""
elif [ ${COPYMADE} = "Y" ]; then
        echo ""
        echo "Configuration files have been saved in ${oldfiles_dir}"
        echo ""
fi

# Remove generated files that do not need to be saved.
if [ -f $APP_HOME/expiry/timeout.dat ]
then
        rm -f $APP_HOME/expiry/timeout.dat
fi

if [ -f $APP_HOME/server_root/ibmproxy-pid ]
then
        rm -f $APP_HOME/server_root/ibmproxy-pid
fi

# Remove backup of new files that were saved during installation
CP_ETC=$APP_HOME/etc

rm -f $CP_ETC/pac.conf.new $CP_ETC/pacpolicy.conf.new $CP_ETC/paccp.conf.new
rm -f $APP_HOME/server_root/filter/cyberpatrol/setup_state.new
# The /etc init.d and rc directories differ on UnitedLinux and Redhat

if [ -f /etc/redhat-release ]; then
        ibmproxy_link="/etc/rc.d/init.d/ibmproxy"
        rcdir="/etc"
        Levels="rc3.d/S88ibmproxy
                rc5.d/S88ibmproxy
                rc0.d/K54ibmproxy
                rc1.d/K54ibmproxy
                rc2.d/K54ibmproxy
                rc6.d/K54ibmproxy"
else
        ibmproxy_link="/etc/init.d/ibmproxy"
        rcdir="/etc/init.d"

        Levels="rc5.d/S20ibmproxy
                rc3.d/S20ibmproxy
                rc5.d/K20ibmproxy
                rc3.d/K20ibmproxy"
fi

# Unlink the links to ibmproxy in the /etc ... rc directories.

rm -f ${ibmproxy_link}

for runlevel in ${Levels}; do
        rm -f ${rcdir}/${runlevel}
done

#if [ "$1" = "0" ] ; then # last uninstall
  rm -f /usr/lib/libpacman.so
  rm -f /usr/lib/libpacwte.so
  rm -f /etc/socks.conf.exp
  rm -f /usr/sbin/cacheagt
  rm -f /usr/sbin/newbomb
  rm -f /usr/lib/libicp.so
  rm -f /usr/lib/jav_wte.so
  rm -f /usr/lib/libhttpdapi.so
  rm -f /usr/lib/libuserapi.so
  rm -f /usr/lib/archive.so
  rm -f /usr/lib/mod_z.so
  rm -f /usr/sbin/cpwizard.sh
  rm -f /etc/pac.conf
  rm -f /etc/paccp.conf
  rm -f /etc/pacpolicy.conf
  rm -f /usr/sbin/pacd
  rm -f /usr/sbin/pacadmin
  rm -f /usr/sbin/pacd_restart.sh
  rm -f /usr/sbin/ibmproxy
  rm -f /usr/sbin/htcformat
  rm -f /usr/sbin/htadm
#fi
#fi
