#!/bin/sh
#if [ "$1" = "0" ] ; then true # last uninstall
# Save all files in a directory
save_files ()
{
FROM_DIR=$1
DEL_FILE=$2
shift 2
for i in $*
do
   if [ -d ${FROM_DIR} ]
   then
        if [ -f ${FROM_DIR}/${i} ]
        then
                cp -p ${FROM_DIR}/${i} ${oldfiles_dir}/${i}.${DATE_SFX}
                cp -fp ${FROM_DIR}/${i} ${oldfiles_dir}
                if [ $? -eq 0 ]
                then
                        if [ "${DEL_FILE}" = "TRUE" ]
                        then
                                rm -f ${FROM_DIR}/${i}
                        fi
                        COPYMADE="Y"
                else
                        ERROR_COPYING="Y"
                fi
        fi
   fi
done
}

# Search a directory list for a copy of the file and save the first one found
save_file_in_dirs ()
{
NOT_FOUND="TRUE"
file_to_save=$1
shift
for dir in $*
do
   if [ -d ${dir} ]
   then
        if [ ${NOT_FOUND} = "TRUE" -a -f ${dir}/$file_to_save ]
        then
           NOT_FOUND="FALSE"
           if [ ${dir} != ${oldfiles_dir} ]
           then
                cp -p ${dir}/${file_to_save} ${oldfiles_dir}/${file_to_save}.${DATE_SFX}
                cp -fp ${dir}/${file_to_save} $oldfiles_dir
                if [ $? -eq 0 ]
                then
                        FILECOPYMADE="Y"
                else
                        ERROR_COPYING="Y"
                fi
           fi
        fi
   fi
done
}

save_dirs ()
{
FROM_DIR=$1
DEL_DIR=$2
shift 2
for i in $*
do
        if [ -d ${FROM_DIR}/${i} ]
        then
                # On Linux, when copying directories, links within them are
                # copied as links; use -L to stop that
                if [ `uname` = "Linux" ]
                then
                        cflags="-rLfp"
                else
                        cflags="-rfp"
                fi

                cp ${cflags} ${FROM_DIR}/${i} ${oldfiles_dir}/${i}.${DATE_SFX}
                cp ${cflags} ${FROM_DIR}/${i} ${oldfiles_dir}

                if [ $? -eq 0 ]
                then
                        if [ "${DEL_DIR}" = "TRUE" ]
                        then
                                rm -rf ${FROM_DIR}/${i}
                        fi
                        COPYMADE=Y
                else
                        ERROR_COPYING="Y"
                fi
        fi
done
}


WES_HOME=/opt/ibm/edge
COMPONENT=cp
APP_HOME=$WES_HOME/$COMPONENT
oldfiles_dir=$WES_HOME/oldfiles/$COMPONENT

OLD_APPHOME="/opt/IBMWTE/usr/internet"
old_oldfiles="${OLD_APPHOME}/server_root/oldfiles"

AIX_GA35="/usr/lpp/internet"    # used for AIX only
aixga35_oldfiles=${AIX_GA35}/server_root/oldfiles


COPYMADE="N"
FILECOPYMADE="N"
DIRCOPYMADE="N"
ERROR_COPYING="N"

# These values are used to indicate if a file should be deleted
# after it is saved. Normally, generated files are deleted.
GENERATED_FILE="TRUE"
INSTALLED_FILE="FALSE"

if [ `uname` = "Linux" ]
then
        DATE=/bin/date
else
        DATE=/usr/bin/date
fi
DATE_SFX=`$DATE '+%y''%m''%d''%H''%M''%SOURCE'`

if [ ! -d ${oldfiles_dir} ]
then
        mkdir -p ${oldfiles_dir}
fi
# Save the language-specific ibmproxy.conf file in a language-specific
# subdir of the oldfiles directory

save_dirs /etc/ibmproxy ${INSTALLED_FILE} cs_CZ

if [ "$COPYMADE" = "N" ]
then
        save_dirs ${APP_HOME}/etc ${INSTALLED_FILE} cs_CZ
fi

if [ ${ERROR_COPYING} = "Y" ]; then
        echo ""
        echo "Error copying configuration files to ${oldfiles_dir},"
        echo "not all files saved."
        echo ""
elif [ ${COPYMADE} = "Y" ]; then
        echo ""
        echo "Configuration files have been saved in ${oldfiles_dir}"
        echo ""
fi

# Remove backup of *.new files that were saved during installation
rm -f $APP_HOME/etc/cs_CZ/ibmproxy.conf.new

#if [ "$1" = "0" ] ; then # last uninstall
  rm -f /etc/ibmproxy.conf
  rm -f /etc/ibmproxy/cs_CZ/ibmproxy.conf
#fi
#fi